 			LIST P=PIC16F628A
;******************************************************************************
;	VFOC-2 Project. : JA9RS  JA3WAO  JA1JDD
;	Freqency display part  Data is transffered by Binary.
;	The displayed Frequency is 15.5MHz-VFO or VFO, controled by RB7
;	Program name is 'cpu2_00.asm'
;	Originated March 1st, 2006
;******************************************************************************
;
	INCLUDE		"P16F628A.INC"
	__CONFIG	_EXTCLK_OSC & _WDT_OFF & _PWRTE_ON & _MCLRE_ON & _LVP_OFF
;
W			EQU		0
TMR0		EQU		1
STATUS		EQU		3
PORTA		EQU		5
PORTB		EQU		6
;
PIR1		EQU		H'0C'
TMR1L		EQU		H'0E'
TMR1H		EQU		H'0F'
T1CON		EQU		H'10'
;
TMR2		EQU		H'11'
T2CON		EQU		H'12'
;
INTCON		EQU		H'0B'
CMCON		EQU		H'1F'
;
OPT			EQU		H'81'
TRISA		EQU		H'85'
TRISB		EQU		H'86'
PIE1		EQU		H'8C'
;
BCDD_1		EQU		H'20'
BCDD_2		EQU		H'21'
BCDD_3		EQU		H'22'
BCDD_4		EQU		H'23'
;
FREQR_1		EQU		H'24'
FREQR_2		EQU		H'25'
FREQR_3		EQU		H'26'
;
WORK1		EQU		H'27'
WORK2		EQU		H'28'
;
CNT0		EQU		H'30'
CNT1		EQU		H'31'
CNT2		EQU		H'32'
;
DLYH		EQU		H'33'
DLYL		EQU		H'34'
;
FLAG1		EQU		H'35'
FLAG2		EQU		H'36'
;
SA_WREG		EQU		H'37'				;FOR W REGISTER	
SA_STATE	EQU		H'38'				;FOR STATUS REGISTER
;
FREQP_1		EQU		H'40'
FREQP_2		EQU		H'41'
FREQP_3		EQU		H'42'
;
;
;-*-===========================================================================
;			CONTROL CONNECTION TO 7 SEGMENT DRIVER AND 7 SEGMENT
;
;			7SEG DRIVER "A"		PORTA,0
;			7SEG DRIVER "B"		PORTA,1
;			7SEG DRIVER "C"		PORTA,2
;			7SEG DRIVER "D"		PORTB,3
;			7SEG DECORDER "A"	PORTB,1
;			7SEG DECORDER "B"	PORTB,2
;			7SEG DECORDER "C"	PORTB,3
;==============================================================================
;			
			ORG			0
			GOTO		MAIN
;
;-----------INTERRUPT ROUTNE---------------------------------------------------
			ORG			4
			GOTO		INT_JOB			;NOT IN USE
;
;
MAIN
			CLRF		STATUS			;CLEAR STATUS REG.
			BSF			STATUS,5		;CHANGE TO PAGE 1
			MOVLW		B'11110000'		;SET PORTA 0-3:OUTPUT, 4-7:INPUT
			MOVWF		TRISA			;BIT 0 :7SEG DRIVER "A"
										;BIT 1 :7SEG DRIVER "B"
										;BIT 2 :7SEG DRIVER "C"
										;BIT 3 :7SEG DRIVER "D"
										;BIT 4 0:DIRECT MODE
										;	   1:"00" MODE		
										;BIT 6 :DATA INPUT FOR DATA RECEIVE
			MOVLW		B'11110001'
			MOVWF		TRISB			;SET PORTB 0, 4-7:INPUT, 1-3 OUTPUT
										;BIT 0 :CHIP SELECT
										;BIT 1 :DECORDER INPUT "A"
										;BIT 2 :DECORDER INPUT "B"
										;BIT 3 :DECORDER INPUT "C"
										;BIT 4 : 
										;BIT 5 :
										;BIT 6 :
										;BIT 7 :
;
			MOVLW		B'00101000'		;PULL UP ENABLE FOR PORTB
			MOVWF		OPT				;TMR0 RISING EDGE DETECT
			BCF			STATUS,5		;CHANGE TO PAGE 0
;
;-----------TURN OFF COMPALATOR MODE-------------------------------------------
			MOVLW		H'07'
			MOVWF		CMCON
;
;-----------INITIALIZE FLAG MEMORY---------------------------------------------
			MOVLW		H'00'			;'0000000'
			MOVWF		FLAG1			;INITIALIZE FLAG1
			CLRF		FLAG2			;INITIALIZE FLAG2
;
;-----------DISABLE INTERRUPT--------------------------------------------------
			CLRF		INTCON
;
			CLRF		PORTB
;
;-----------INITIALIZE BCD DATA------------------------------------------------
			MOVLW		H'00'
			MOVWF		BCDD_1
			MOVLW		H'00'
			MOVWF		BCDD_2
			MOVLW		H'88'
			MOVWF		BCDD_3
			CLRF		BCDD_4
;
;==============================================================================
;			MAIN ROUTINE
;==============================================================================
LOOP_START
;
LOOP_000
;-----------SET ADJUST FREQUENCY (10,500,000Hz - VFO )-------------------------
			MOVLW		H'A0'
			MOVWF		FREQP_1
			MOVLW		H'37'
			MOVWF		FREQP_2
			MOVLW		H'A0'
			MOVWF		FREQP_3
;
;=========== 1HZ ORDER ========================================================
			MOVF		BCDD_1,0
			MOVWF		PORTA
			BCF			PORTB,1			;DISPLAY x1HZ
			BCF			PORTB,2
			BCF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_001
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_001
;
;=========== 10HZ ORDER =======================================================
			SWAPF		BCDD_1,0		;SWAP UPPER 4 AND LOWER 4
			MOVWF		PORTA
			BSF			PORTB,1			;DISPLAY x10HZ
			BCF			PORTB,2
			BCF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_002
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_002
;
;=========== 100HZ ORDER ======================================================
			MOVF		BCDD_2,0
			MOVWF		PORTA
			BCF			PORTB,1			;DISPLAY x100HZ
			BSF			PORTB,2
			BCF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_003
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_003
;
;=========== 1KHZ ORDER =======================================================
			SWAPF		BCDD_2,0		;SWAP UPPER 4 AND LOWER 4
			MOVWF		PORTA
			BSF			PORTB,1			;DISPLAY x1KHZ
			BSF			PORTB,2
			BCF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_004
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_004
;
;=========== 10KHZ ORDER ======================================================
			MOVF		BCDD_3,0
			MOVWF		PORTA
			BCF			PORTB,1			;DISPLAY x10KHZ
			BCF			PORTB,2
			BSF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_005
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_005
;
;=========== 100KHZ ORDER =====================================================
			SWAPF		BCDD_3,0		;SWAP UPPER 4 AND LOWER 4
			MOVWF		PORTA
			BSF			PORTB,1			;DISPLAY x100KHZ
			BCF			PORTB,2
			BSF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_006
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_006
;
;=========== 1MKHZ ORDER ======================================================
			MOVF		BCDD_4,0
			MOVWF		PORTA
			BCF			PORTB,1			;DISPLAY x1MHZ
			BSF			PORTB,2
			BSF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_007
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_007
;
;=========== 10MHZ ORDER ======================================================
			SWAPF		BCDD_4,0		;SWAP UPPER 4 AND LOWER 4
			MOVWF		PORTA
			BSF			PORTB,1			;DISPLAY x10MHZ
			BSF			PORTB,2
			BSF			PORTB,3
			MOVLW		H'05'
			MOVWF		DLYL
LOOP_008
			BTFSC		PORTB,0			;RB0 IS HIGH ?
			CALL		DATA_REC		;YES,
			CALL		WAITU100
			DECFSZ		DLYL
			GOTO		LOOP_008
;
;
			GOTO		LOOP_000
;
;
;------------------------------------------------------------------------------
;	SUBROUTINE AREA	-1-		INTERRUPT JOB(NOT IN USE)
;------------------------------------------------------------------------------
INT_JOB
			MOVWF		SA_WREG			;SAVE W REGISTER
			SWAPF		STATUS,0		;PROTECT STATUS FLAG
			MOVWF		SA_STATE		;SAVE STATUS REGISTER
;
			BSF			FLAG2,0			;SET INTERRUPT FLAG
			BCF			PORTB,2			;YELLOW LED ON
			BSF			PORTA,2			;7474 D TRIGGER ON
;
			CLRF		INTCON			;DISABLE INTERRUPT
;
			SWAPF		SA_STATE,0		;PROTECT STATUS FLAG
			MOVWF		STATUS			;RECOVER STATUS REGISTER
			SWAPF		SA_WREG,1		;TRANSFER TO W REGISTER
			SWAPF		SA_WREG,0		;RECOVER W REGISTER
;
			RETFIE
;
;
;------------------------------------------------------------------------------
;			SUBROUTINE AREA -2-	DATA RECEIVE AND CONVERT TO BCD
;------------------------------------------------------------------------------
DATA_REC
			MOVLW		H'08'
			MOVWF		CNT1			;SET COUNT VALUE
			CLRF		FREQR_1			;CLEAR FREQR_1
DATA_REC_00
			BTFSS		PORTB,0			;IF CHIP SELECT IS LOW ?
			GOTO		DATA_REC_OUT	;
			BTFSS		PORTA,6			;IF START BIT ?
			GOTO		DATA_REC_00		;NO, NOT HIGH YET
;
			CALL		WAITU004		;WAIT TO CENTER OF START PULSE
DATA_REC_01
			CLRC						;CLEAR CARRY
			CALL		WAITU010		;WAIT 10US FOR NEXT SAMPLING
			BTFSC		PORTA,6			;IF DATA IS HIGH ?
			BSF			STATUS,0		;SET CARRY
			RRF			FREQR_1,1
			DECFSZ		CNT1,1
			GOTO		DATA_REC_01		;GET NEXT DATA
			CALL		WAITU010
;
			MOVLW		H'08'
			MOVWF		CNT1			;SET COUNT VALUE
			CLRF		FREQR_2			;CLEAR FREQR_2
DATA_REC_02
			BTFSS		PORTB,0			;IF CHIP SELECT IS LOW ?
			GOTO		DATA_REC_OUT	;
			BTFSS		PORTA,6			;IF START BIT ?
			GOTO		DATA_REC_02		;NO, NOT HIGH YET
;
			CALL		WAITU004		;WAIT TO CENTER OF START PULSE
DATA_REC_03
			CLRC						;CLEAR CARRY
			CALL		WAITU010		;WAIT 10US FOR NEXT SAMPLING
			BTFSC		PORTA,6			;IF DATA IS HIGH ?
			BSF			STATUS,0		;SET CARRY
			RRF			FREQR_2,1
			DECFSZ		CNT1,1
			GOTO		DATA_REC_03		;GET NEXT DATA
			CALL		WAITU010
;
			MOVLW		H'08'
			MOVWF		CNT1			;SET COUNT VALUE
			CLRF		FREQR_3			;CLEAR FREQR_2
DATA_REC_04
			BTFSS		PORTB,0			;IF CHIP SELECT IS LOW ?
			GOTO		DATA_REC_OUT	;
			BTFSS		PORTA,6			;IF START BIT ?
			GOTO		DATA_REC_04		;NO, NOT HIGH YET
;
			CALL		WAITU004		;WAIT TO CENTER OF START PULSE
DATA_REC_05
			CALL		WAITU010		;WAIT 10US FOR NEXT SAMPLING
			CLRC						;CLEAR CARRY
			BTFSC		PORTA,6			;IF DATA IS HIGH ?
			BSF			STATUS,0		;SET CARRY
			RRF			FREQR_3,1
			DECFSZ		CNT1,1
			GOTO		DATA_REC_05		;GET NEXT DATA
			CALL		WAITU010
;

DATA_REC_OUT
			BTFSC		PORTB,0			;STILL CHIP SELECTED ?
			GOTO		DATA_REC_OUT
;
;
;-----------ADJUST DISPLAY DATA (10.500MHz - VFO)------------------------------
			BTFSC		PORTA,4			;IF DIRECT MODE ?
			GOTO		CONV_00			;YES,			
;
			BTFSC		PORTB,7			;IF RB7 IS HIGH ?
			GOTO		CONV_00			;YES, NO ADJUST.
;
			MOVF		FREQR_3,0
			CLRC
			SUBWF		FREQP_3,0		;W=FREQP_3 - FREQR_3
			MOVWF		FREQR_3
;
			MOVF		FREQR_2,0
			CLRC
			SUBWF		FREQP_2,0		;W=FREQP_2-FREQR_2 
			MOVWF		FREQR_2			;FREQR_2=W			
			BTFSC		STATUS,0		;FREQP_2>=FREQR_2 ?
			GOTO		CALC_01			;YES,
;
			MOVLW		H'01'
			SUBWF		FREQR_3,1
;
CALC_01
			MOVF		FREQR_1,0		;W=FREQR_1
			CLRC
			SUBWF		FREQP_1,0		;W=FREQP_1-FREQR_1
			MOVWF		FREQR_1			;FREQR_1=W
			BTFSC		STATUS,0		;IF FREQP_1>=FREQR_1 ?
			GOTO		CALC_END		;YES,
;
			MOVLW		H'01'
			CLRC
			SUBWF		FREQR_2,1		;FREQR_2=FREQR_2-1
			BTFSC		STATUS,0		;IF FREQR_2-1>=0
			GOTO		CALC_END
;
			MOVLW		H'01'
			SUBWF		FREQR_3,1		;FREQR_3=FREQR_3-1
;
CALC_END
;-----------DATA CONVERSION FROM BINARY TO BCD---------------------------------
CONV_00
			BCF			STATUS,0		;CLEAR CARRY FLAG
			MOVLW		H'18'			;SET SHIFT COUNT
			MOVWF		CNT1
			CLRF		BCDD_1			;CLEAR BCD MEMORY
			CLRF		BCDD_2
			CLRF		BCDD_3
			CLRF		BCDD_4
;
CONV_10
			RLF			FREQR_1,1
			RLF			FREQR_2,1
			RLF			FREQR_3,1
			RLF			BCDD_1,1
			RLF			BCDD_2,1
			RLF			BCDD_3,1
			RLF			BCDD_4,1
			DECFSZ		CNT1,1			;IF END ?
			GOTO		ADJUST_0
;
			GOTO		CONV_END00
;
ADJUST_0
			MOVF		BCDD_1,0
			CALL		EXE_BCD
			MOVWF		BCDD_1
;
			MOVF		BCDD_2,0
			CALL		EXE_BCD
			MOVWF		BCDD_2
;
			MOVF		BCDD_3,0
			CALL		EXE_BCD
			MOVWF		BCDD_3
;
			MOVF		BCDD_4,0
			CALL		EXE_BCD
			MOVWF		BCDD_4
;
			GOTO		CONV_10
;
CONV_END00
;-----------CHECK IF 00/DIRECT MODE FOR DISPLAY--------------------------------
			BTFSC		PORTA,4			;IF DIRECT MODE ?
			GOTO		CONV_END01		;YES,
;
			MOVLW		H'F0'
			ANDWF		BCDD_1,1		;MAKE LSB 4 BITS TO '0'
;
			MOVF		BCDD_1,0
			CLRC
			ADDLW		H'70'
			BTFSS		STATUS,0		;CHECK IF NOT MSB 4BITS IS '9' ?
			GOTO		CONV_END01		;NO,
;
			MOVLW		H'0F'
			ANDWF		BCDD_1,1		;MAKE MSB 4 BITS TO '0'
;
			MOVF		BCDD_2,0
			ADDLW		H'01'
			MOVWF		BCDD_2
			CLRDC
			ADDLW		H'06'
			BTFSS		STATUS,1		;CHECK IF NOT LSB 4BITS IS '9' ?
			GOTO		CONV_END01		;NO,
;
			MOVLW		H'F0'
			ANDWF		BCDD_2,1		;MAKE LSB 4 BITS TO '0'
;
			MOVF		BCDD_2,0
			ADDLW		H'10'
			MOVWF		BCDD_2
			CLRC
			ADDLW		H'60'
			BTFSS		STATUS,0		;CHECK IF NOT MSB 4 BITS IS '9' ?
			GOTO		CONV_END01		;NO,
;
			MOVLW		H'0F'
			ANDWF		BCDD_2,1		;MAKE MSB 4 BITS TO '0'
;
			MOVF		BCDD_3,0
			ADDLW		H'01'
			MOVWF		BCDD_3
			CLRDC
			ADDLW		H'06'
			BTFSS		STATUS,1		;CHECK IF NOT LSB 4BITS IS '9' ?
			GOTO		CONV_END01		;NO,
;
			MOVLW		H'F0'
			ANDWF		BCDD_3,1		;MAKE LSB 4 BITS TO '0'
;
			MOVF		BCDD_3,0
			ADDLW		H'10'
			MOVWF		BCDD_3
			CLRC
			ADDLW		H'60'
			BTFSS		STATUS,0		;CHECK IF NOT MSB 4 BITS IS '9' ?
			GOTO		CONV_END01		;NO,
;
			MOVLW		H'0F'
			ANDWF		BCDD_3,1		;MAKE MSB 4 BITS TO '0'
;
			MOVF		BCDD_4,0
			ADDLW		H'01'
			MOVWF		BCDD_4
			CLRDC
			ADDLW		H'06'
			BTFSS		STATUS,1		;CHECK IF NOT LSB 4BITS IS '9' ?
			GOTO		CONV_END01		;NO,
;
			MOVLW		H'F0'
			ANDWF		BCDD_4,1		;MAKE LSB 4 BITS TO '0'
;
			MOVF		BCDD_4,0
			ADDLW		H'10'
			MOVWF		BCDD_4
;
CONV_END01
			RETURN
;
;
;-----------SUB-ROUTINE FOR HEX TO BCD-----------------------------------------
EXE_BCD
			MOVWF		WORK1			;SAVE
			MOVLW		H'03'			;W+3H
			ADDWF		WORK1,0
			MOVWF		WORK2
			BTFSC		WORK2,3
			MOVWF		WORK1			;>7 THEN W+3H ELSE W
;
			MOVLW		H'30'			;W+30H
			ADDWF		WORK1,0
			MOVWF		WORK2
			BTFSC		WORK2,7
			MOVWF		WORK1			;>70 THEN W+30H ELSE W
			MOVF		WORK1,0
			RETURN
;
;
;------------------------------------------------------------------------------
;			SUBROUTINE AREA	-6-	TIMER
;------------------------------------------------------------------------------
WAIT500
			MOVLW		H'0C'			;WAIT 500mS
			MOVWF		CNT0
;
WAIT501
			MOVLW		H'A6'			;WAIT 40mS
			MOVWF		DLYH
			CLRF		DLYL
WAIT502
			DECFSZ		DLYL,1
			GOTO		WAIT502
			DECFSZ		DLYH,1
			GOTO		WAIT502
;
			DECFSZ		CNT0,1
			GOTO		WAIT501
;
			RETURN
;
WAIT020
			MOVLW		H'53'			;WAIT 20mS
			MOVWF		DLYH
			CLRF		DLYL
;
WAIT021
			DECFSZ		DLYL,1
			GOTO		WAIT021
			DECFSZ		DLYH,1
			GOTO		WAIT021
			RETURN
;
WAITU5000
			MOVLW		H'15'			;WAIT 5mS
			MOVWF		DLYH
			CLRF		DLYL
;
WAITU5001
			DECFSZ		DLYL,1
			GOTO		WAITU5001
			DECFSZ		DLYH,1
			GOTO		WAITU5001
			RETURN
;
WAITU1000
			MOVLW		H'05'			;WAIT 1mS
			MOVWF		DLYH
			MOVLW		H'20'
			MOVWF		DLYL
WAITU1001
			DECFSZ		DLYL,1
			GOTO		WAITU1001
			DECFSZ		DLYH,1
			GOTO		WAITU1001
			RETURN
;
WAITU500
			MOVLW		H'03'			;WAIT 500uS
			MOVWF		DLYH
			MOVLW		H'20'
			MOVWF		DLYL
WAITU501
			DECFSZ		DLYL,1
			GOTO		WAITU501
			DECFSZ		DLYH,1
			GOTO		WAITU501
			RETURN
;
WAITU200
			MOVLW		H'D4'			;WAIT 200uS
			MOVWF		DLYH
WAITU201
			DECFSZ		DLYH,1
			GOTO		WAITU201
			RETURN
;
WAITU100
			MOVLW		H'6A'			;WAIT 100uS
			MOVWF		DLYH
WAITU101
			DECFSZ		DLYH,1
			GOTO		WAITU101
			RETURN
;
WAITU050
			MOVLW		H'35'			;WAIT 50uS
			MOVWF		DLYH
WAITU051
			DECFSZ		DLYH,1
			GOTO		WAITU051
			RETURN
;
WAITU020
			MOVLW		H'15'			;WAIT 20uS
			MOVWF		DLYH
WAITU021
			DECFSZ		DLYH,1
			GOTO		WAITU021
			RETURN
;
WAITU010
			MOVLW		H'09'			;WAIT 10uS
			MOVWF		DLYH
WAITU011
			DECFSZ		DLYH,1
			GOTO		WAITU011
			NOP
			RETURN
;
WAITU004
			MOVLW		H'02'			;WAIT 4uS
			MOVWF		DLYH
WAITU041
			DECFSZ		DLYH,1
			GOTO		WAITU041
			RETURN
;
;
WAITU002
			NOP
			NOP
			NOP
			RETURN
;
;
			END

